#include <stdio.h>
#include <iostream>
#include "opencv2/core/core.hpp"
#include "opencv2/features2d/features2d.hpp"
#include "opencv2/highgui/highgui.hpp"

using namespace cv;

int main ( int argc, char **argv )
{
	Mat img_1;
	if (argc > 0) {
		img_1 = imread( argv[1], CV_LOAD_IMAGE_GRAYSCALE);
	}
	else {
		std::cout<< " --(!) Please give the input file as parameter! " << std::endl; 
		return -1; 
	}
	if( !img_1.data ) {
		std::cout<< " --(!) Error reading images " << std::endl; return -1; 
	}
	int minHessian = 400;

	SurfFeatureDetector detector( minHessian );

	std::vector<KeyPoint> keypoints_1;

	detector.detect( img_1, keypoints_1 );
	// std::cout << "Number of keypoints found: " << (int) keypoints_1.size() << std::endl;

	// check if there actually are key points.
	if (keypoints_1.size() < 1)
		return 0;

	SurfDescriptorExtractor extractor;
	Mat descriptors_1;
	extractor.compute( img_1, keypoints_1, descriptors_1 );
	std::cout << "# <point.x> <point.y> <response> <descriptor00> <descriptor01> <descriptor02> ..." << std::endl;
	for (int i = 0; i < descriptors_1.rows; i++){
		std::cout << keypoints_1.at(i).pt.x << " " << keypoints_1.at(i).pt.y << " " << keypoints_1.at(i).response << " " ;
		const double* Mi = descriptors_1.ptr<double>(i);
		for(int j = 0; j < descriptors_1.cols; j++)
			std::cout << Mi[j] << " ";
		std::cout << std::endl;
	}
	return 0;
}